//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Settings.h"
#include <stdio.h>

//---------------------------------------------------------------------------

#pragma link "jsoncpp.lib"

#pragma argsused
int main(int argc, char* argv[])
{
	AnsiString asConfigFile = ChangeFileExt( Application->ExeName, ".json" );
	int rc = appSettings.Read(asConfigFile);
	if (rc)
	{
        appSettings.Write(asConfigFile);
    }

	if (argc < 2)
	{
		printf("Argument is missing (name of the file to process), exiting\n");
		return -1;
	}
	AnsiString asInputName = argv[1];

	STARTUPINFO si;
	PROCESS_INFORMATION pi;
    ZeroMemory( &si, sizeof(si) ); 
	si.cb = sizeof(si);
	ZeroMemory( &pi, sizeof(pi) );

	si.dwFlags = STARTF_USESHOWWINDOW;
	si.wShowWindow = SW_HIDE;

	AnsiString asApp;
	asApp = ExtractFileDir(Application->ExeName) + "\\opusenc.exe";

	AnsiString asOutputName = ChangeFileExt(asInputName, ".opus");

	AnsiString asCmdLine;
	asCmdLine.sprintf("\"%s\" %s \"%s\" \"%s\" ",
		asApp.c_str(), appSettings.Conversion.params.c_str(), asInputName.c_str(), asOutputName.c_str());

	printf("cmdline = %s\n", asCmdLine.c_str());

	// Start the child process.
	if( !CreateProcess( NULL, // No module name (use command line)
		asCmdLine.c_str(), // Command line
		NULL, // Process handle not inheritable
		NULL, // Thread handle not inheritable
		FALSE, // Set handle inheritance to FALSE
		NORMAL_PRIORITY_CLASS,
		NULL, // Use parent's environment block
		NULL, // Use parent's starting directory
		&si, // Pointer to STARTUPINFO structure
		&pi ) // Pointer to PROCESS_INFORMATION structure
		)
	{
		printf( "CreateProcess for opusenc.exe failed (%d)", GetLastError() );
		return -2;
	}

	// Wait until child process exits.
	WaitForSingleObject( pi.hProcess, INFINITE );

	DWORD exitCode;
	BOOL result = GetExitCodeProcess(pi.hProcess, &exitCode);

	// Close process and thread handles.
	CloseHandle( pi.hProcess );
	CloseHandle( pi.hThread );

	if (result)
	{
		if (exitCode == 0)
		{
			if (DeleteFile(asInputName) == false)
			{
				printf("Error deleting %s", asInputName.c_str());
			}
		}
		else
		{
			printf("Error converting %s", asInputName.c_str());
		}
	}
	else
	{
		printf("Could not get status code from opusenc.exe");
	}
	

	return 0;
}
//---------------------------------------------------------------------------
